/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.43 Revision 1.66
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.43 2007/03/13 09:48:02 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.66 2009/02/23 23:46:31 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77
78DEPEND="${COMMON_DEPEND}
77DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
78 80RDEPEND="${COMMON_DEPEND}
79 81 >=app-admin/eselect-vdr-0.0.2"
80# this code is from linux-mod.eclass
81update_vdrplugindb() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
83
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102 82
103# New method of storing plugindb 83# New method of storing plugindb
104# Called from src_install 84# Called from src_install
105# file maintained by normal portage-methods 85# file maintained by normal portage-methods
106create_plugindb_file() { 86create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 87 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 88 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
109 insinto ${NEW_VDRPLUGINDB_DIR} 89 insinto "${NEW_VDRPLUGINDB_DIR}"
90
91# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
110 cat <<-EOT > ${D}/${DB_FILE} 92# cat <<-EOT > "${D}/${DB_FILE}"
111 VDRPLUGIN_DB=1 93# VDRPLUGIN_DB=1
112 CREATOR=ECLASS 94# CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN} 95# EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR} 96# EBUILD_V=${PVR}
115 EOT 97# EOT
98 {
99 echo "VDRPLUGIN_DB=1"
100 echo "CREATOR=ECLASS"
101 echo "EBUILD=${CATEGORY}/${PN}"
102 echo "EBUILD_V=${PVR}"
103 echo "PLUGINS=\"$@\""
104 } > "${D}/${DB_FILE}"
116} 105}
117 106
118# Delete files created outside of vdr-plugin.eclass 107# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are 108# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as 109# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to 110# long as not every system has switched over to
122# vdrplugin-rebuild-0.2 111# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
123delete_orphan_plugindb_file() { 112delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file 113 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 114 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 115 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
127 116
128 # file exists 117 # file exists
129 [[ -f ${DB_FILE} ]] || return 118 [[ -f ${DB_FILE} ]] || return
130 119
131 # will portage handle the file itself 120 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then 121 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
133 #elog file owned by eclass - don't touch it 122 #elog file owned by eclass - don't touch it
134 return 123 return
135 fi 124 fi
136 125
137 elog "Removing orphaned plugindb-file." 126 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}" 127 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE} 128 rm "${DB_FILE}"
140} 129}
130
131
132create_header_checksum_file()
133{
134 # Danger: Not using $ROOT here, as compile will also not use it !!!
135 # If vdr in $ROOT and / differ, plugins will not run anyway
136
137 local CHKSUM="header-md5-vdr"
138
139 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
140 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
141 elif type -p md5sum >/dev/null 2>&1; then
142 (
143 cd "${VDR_INCLUDE_DIR}"
144 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
145 ) > "${CHKSUM}"
146 else
147 die "Could not create md5 checksum of headers"
148 fi
149
150 insinto "${VDR_CHECKSUM_DIR}"
151 local p_name
152 for p_name; do
153 newins "${CHKSUM}" "header-md5-${p_name}"
154 done
155}
156
157fix_vdr_libsi_include()
158{
159 einfo "Fixing include of libsi-headers"
160 local f
161 for f; do
162 sed -i "${f}" \
163 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
164 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
165 done
166}
167
168vdr_patchmakefile() {
169 einfo "Patching Makefile"
170 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
171 cp Makefile "${WORKDIR}"/Makefile.before
172
173 # plugin makefiles use VDRDIR in strange ways
174 # assumptions:
175 # 1. $(VDRDIR) contains Make.config
176 # 2. $(VDRDIR) contains config.h
177 # 3. $(VDRDIR)/include/vdr contains the headers
178 # 4. $(VDRDIR) contains main vdr Makefile
179 # 5. $(VDRDIR)/locale exists
180 # 6. $(VDRDIR) allows to access vdr source files
181 #
182 # We only have one directory (for now /usr/include/vdr),
183 # that contains vdr-headers and Make.config.
184 # To satisfy 1-3 we do this:
185 # Set VDRDIR=/usr/include/vdr
186 # Set VDRINCDIR=/usr/include
187 # Change $(VDRDIR)/include to $(VDRINCDIR)
188
189 ebegin " Setting paths"
190 sed -i Makefile \
191 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
192 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
193 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
194 \
195 -e 's:-I$(DVBDIR)/include::' \
196 -e 's:-I$(DVBDIR)::'
197 eend 0
198
199 # maybe needed for multiproto:
200 #sed -i Makefile \
201 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
202 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
203
204 if ! grep -q APIVERSION Makefile; then
205 ebegin " Converting to APIVERSION"
206 sed -i Makefile \
207 -e 's:^APIVERSION = :APIVERSION ?= :' \
208 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
209 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
210 eend $?
211 fi
212
213 # Correcting Compile-Flags
214 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
215 sed -i Makefile \
216 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
217 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
218
219 # Disabling file stripping, useful for debugging
220 sed -i Makefile \
221 -e '/@.*strip/d' \
222 -e '/strip \$(LIBDIR)\/\$@/d' \
223 -e '/@.*\$(STRIP)/d'
224
225 # Use a file instead of a variable as single-stepping via ebuild
226 # destroys environment.
227 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
228}
229
230vdr_add_local_patch() {
231 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
232 echo
233 einfo "Applying local patches"
234 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
235 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
236 done
237 fi
238}
239
240vdr_has_gettext() {
241 has_version ">=media-video/vdr-1.5.7"
242}
243
244plugin_has_gettext() {
245 [[ -d po ]]
246}
247
248vdr_i18n_convert_to_gettext() {
249 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
250
251 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
252 ewarn "Conversion to gettext disabled in ebuild"
253 return 1
254 fi
255
256 if [[ ! -x ${i18n_tool} ]]; then
257 eerror "Missing ${i18n_tool}"
258 eerror "Please re-emerge vdr"
259 die "Missing ${i18n_tool}"
260 fi
261
262 ebegin "Auto converting translations to gettext"
263 # call i18n-to-gettext tool
264 # take all texts missing tr call into special file
265 "${i18n_tool}" 2>/dev/null \
266 |sed -e '/^"/!d' \
267 -e '/^""$/d' \
268 -e 's/\(.*\)/trNOOP(\1)/' \
269 > dummy-translations-trNOOP.c
270
271 # if there were untranslated texts just run it again
272 # now the missing calls are listed in
273 # dummy-translations-trNOOP.c
274 if [[ -s dummy-translations-trNOOP.c ]]; then
275 "${i18n_tool}" &>/dev/null
276 fi
277
278 # now use the modified Makefile
279 if [[ -f Makefile.new ]]; then
280 mv Makefile.new Makefile
281 eend 0 ""
282 else
283 eend 1 "Conversion to gettext failed. Plugin needs fixing."
284 return 1
285 fi
286}
287
288vdr_i18n_disable_gettext() {
289 ebegin "Disabling gettext support in plugin"
290 # Remove i18n Target if using older vdr
291 sed -i Makefile \
292 -e '/^all:/s/ i18n//'
293 eend 0
294}
295
296vdr_i18n() {
297 if vdr_has_gettext; then
298 einfo "VDR has gettext support"
299 if plugin_has_gettext; then
300 einfo "Plugin has gettext support, fine"
301 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
302 ewarn "Please remove left over NO_GETTEXT_HACK."
303 fi
304 else
305 vdr_i18n_convert_to_gettext
306 if [[ $? != 0 ]]; then
307 eerror ""
308 eerror "Plugin will have only english OSD texts"
309 eerror "it needs manual fixing."
310 fi
311 fi
312 else
313 einfo "VDR has no gettext support"
314 if plugin_has_gettext; then
315 vdr_i18n_disable_gettext
316 fi
317 fi
318}
319
320vdr-plugin_copy_source_tree() {
321 pushd . >/dev/null
322 cp -r "${S}" "${T}"/source-tree
323 cd "${T}"/source-tree
324 cp "${WORKDIR}"/Makefile.before Makefile
325 # TODO: Fix this, maybe no longer needed
326 sed -i Makefile \
327 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
328 -e 's:^CXXFLAGS:#CXXFLAGS:' \
329 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
330 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
331 popd >/dev/null
332}
333
334vdr-plugin_install_source_tree() {
335 einfo "Installing sources"
336 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
337 insinto "${destdir}-${PV}"
338 doins -r "${T}"/source-tree/*
339
340 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
341}
342
343vdr-plugin_print_enable_command() {
344 local p_name c=0 l=""
345 for p_name in ${vdr_plugin_list}; do
346 c=$(( c+1 ))
347 l="$l ${p_name#vdr-}"
348 done
349
350 elog
351 case $c in
352 1) elog "Installed plugin${l}" ;;
353 *) elog "Installed $c plugins:${l}" ;;
354 esac
355 elog "To activate a plugin execute this command:"
356 elog "\teselect vdr-plugin enable <plugin_name> ..."
357 elog
358}
359
360
361## exported functions
141 362
142vdr-plugin_pkg_setup() { 363vdr-plugin_pkg_setup() {
143 # -fPIC is needed for shared objects on some platforms (amd64 and others) 364 # -fPIC is needed for shared objects on some platforms (amd64 and others)
144 append-flags -fPIC 365 append-flags -fPIC
145 366
153 374
154 # Pathes to includes 375 # Pathes to includes
155 VDR_INCLUDE_DIR="/usr/include/vdr" 376 VDR_INCLUDE_DIR="/usr/include/vdr"
156 DVB_INCLUDE_DIR="/usr/include" 377 DVB_INCLUDE_DIR="/usr/include"
157 378
379 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
380 LOCDIR="/usr/share/vdr/locale"
158 381
159 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 382 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
160 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 383 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
161 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 384 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
162 385
163 einfo "Building ${PF} against vdr-${VDRVERSION}" 386 einfo "Compiling against"
164 einfo "APIVERSION: ${APIVERSION}" 387 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
388}
389
390vdr-plugin_src_util() {
391
392 while [ "$1" ]; do
393
394 case "$1" in
395 all)
396 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
397 ;;
398 all_but_unpack)
399 vdr-plugin_src_util add_local_patch patchmakefile i18n
400 ;;
401 unpack)
402 base_src_unpack
403 ;;
404 add_local_patch)
405 cd "${S}" || die "Could not change to plugin-source-directory!"
406 vdr_add_local_patch
407 ;;
408 patchmakefile)
409 cd "${S}" || die "Could not change to plugin-source-directory!"
410 vdr_patchmakefile
411 ;;
412 i18n)
413 cd "${S}" || die "Could not change to plugin-source-directory!"
414 vdr_i18n
415 ;;
416 esac
417
418 shift
419 done
165} 420}
166 421
167vdr-plugin_src_unpack() { 422vdr-plugin_src_unpack() {
168 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 423 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
169 eerror "Wrong use of vdr-plugin.eclass." 424 eerror "Wrong use of vdr-plugin.eclass."
170 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 425 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
171 echo 426 echo
172 eerror "Please report this at bugs.gentoo.org." 427 eerror "Please report this at bugs.gentoo.org."
173 die "vdr-plugin_pkg_setup not called!" 428 die "vdr-plugin_pkg_setup not called!"
174 fi 429 fi
175 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile 430 if [ -z "$1" ]; then
176 431 case "${EAPI:-0}" in
177 while [ "$1" ]; do 432 2)
178 433 vdr-plugin_src_util unpack
179 case "$1" in
180 all_but_unpack)
181 vdr-plugin_src_unpack add_local_patch patchmakefile
182 ;; 434 ;;
183 unpack) 435 *)
184 base_src_unpack 436 vdr-plugin_src_util all
185 ;; 437 ;;
186 patchmakefile)
187 if ! cd ${S}; then
188 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
189 ewarn "Perhaps you find one among these:"
190 cd "${WORKDIR}"
191 ewarn "$(/bin/ls -1 ${WORKDIR})"
192 die "Could not change to plugin-source-directory!"
193 fi
194
195 einfo "Patching Makefile"
196 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
197 cp Makefile Makefile.orig
198
199 sed -i Makefile \
200 -e '1i\#Makefile was patched by vdr-plugin.eclass'
201
202 ebegin " Setting Pathes"
203 sed -i Makefile \
204 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
205 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
206 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
207 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
208 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
209 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
210 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
211 eend $?
212
213 ebegin " Converting to APIVERSION"
214 sed -i Makefile \
215 -e 's:^APIVERSION = :APIVERSION ?= :' \
216 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
217 -e '2i\APIVERSION = '"${APIVERSION}"
218 eend $?
219
220 ebegin " Correcting Compile-Flags"
221 sed -i Makefile \
222 -e 's:^CXXFLAGS:#CXXFLAGS:' \
223 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
224 eend $?
225
226 ebegin " Disabling file stripping"
227 sed -i Makefile \
228 -e '/@.*strip/d' \
229 -e '/strip \$(LIBDIR)\/\$@/d' \
230 -e '/^STRIP =/d' \
231 -e '/@.*\$(STRIP)/d'
232 eend $?
233
234 # Use a file instead of an variable as single-stepping via ebuild
235 # destroys environment.
236 touch ${WORKDIR}/.vdr-plugin_makefile_patched
237 ;;
238 add_local_patch)
239 cd ${S}
240 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
241 echo
242 einfo "Applying local patches"
243 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
244 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
245 done
246 fi
247 ;;
248 esac 438 esac
249 439
250 shift 440 else
251 done 441 vdr-plugin_src_util $@
442 fi
252} 443}
253 444
254vdr-plugin_copy_source_tree() { 445vdr-plugin_src_prepare() {
255 pushd . >/dev/null 446 vdr-plugin_src_util all_but_unpack
256 cp -r ${S} ${T}/source-tree
257 cd ${T}/source-tree
258 mv Makefile.orig Makefile
259 sed -i Makefile \
260 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
261 -e 's:^CXXFLAGS:#CXXFLAGS:' \
262 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
263 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
264 popd >/dev/null
265}
266
267vdr-plugin_install_source_tree() {
268 einfo "Installing sources"
269 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
270 insinto ${destdir}-${PV}
271 doins -r ${T}/source-tree/*
272
273 dosym ${VDRPLUGIN}-${PV} ${destdir}
274} 447}
275 448
276vdr-plugin_src_compile() { 449vdr-plugin_src_compile() {
277 [ -z "$1" ] && vdr-plugin_src_compile prepare compile 450 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
278 451
289 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 462 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
290 echo 463 echo
291 eerror "Please report this at bugs.gentoo.org." 464 eerror "Please report this at bugs.gentoo.org."
292 die "vdr-plugin_src_unpack not called!" 465 die "vdr-plugin_src_unpack not called!"
293 fi 466 fi
294 cd ${S} 467 cd "${S}"
295 468
296 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 469 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
470
471 emake ${BUILD_PARAMS} \
472 ${BUILD_TARGETS} \
473 LOCALEDIR="${TMP_LOCALE_DIR}" \
474 LIBDIR="${S}" \
475 TMPDIR="${T}" \
476 || die "emake failed"
297 ;; 477 ;;
298 esac 478 esac
299 479
300 shift 480 shift
301 done 481 done
302} 482}
303 483
304vdr-plugin_src_install() { 484vdr-plugin_src_install() {
305 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 485 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
306 cd ${S} 486 cd "${WORKDIR}"
307 487
308 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 488 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
309 local mname=${P}-Makefile 489 local mname="${P}-Makefile"
310 cp Makefile ${mname}.patched 490 cp "${S}"/Makefile "${mname}.patched"
311 cp Makefile.orig ${mname}.before 491 cp Makefile.before "${mname}.before"
312 492
313 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 493 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
314 494
315 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 495 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
316 doins ${mname}.diff 496 doins "${mname}.diff"
317 497
318 insinto "/usr/share/vdr/maintainer-data/makefile-before" 498 insinto "/usr/share/vdr/maintainer-data/makefile-before"
319 doins ${mname}.before 499 doins "${mname}.before"
320 500
321 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 501 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
322 doins ${mname}.patched 502 doins "${mname}.patched"
323 503
324 fi 504 fi
325 505
506
507
508 cd "${S}"
326 insinto "${VDR_PLUGIN_DIR}" 509 insinto "${VDR_PLUGIN_DIR}"
327 doins libvdr-*.so.* 510 doins libvdr-*.so.*
511
512 # create list of all created plugin libs
513 vdr_plugin_list=""
514 local p_name
515 for p in libvdr-*.so.*; do
516 p_name="${p%.so*}"
517 p_name="${p_name#lib}"
518 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
519 done
520
521 create_header_checksum_file ${vdr_plugin_list}
522 create_plugindb_file ${vdr_plugin_list}
523
524 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
525 einfo "Installing locales"
526 cd "${TMP_LOCALE_DIR}"
527 insinto "${LOCDIR}"
528 doins -r *
529 fi
530
531 cd "${S}"
328 local docfile 532 local docfile
329 for docfile in README* HISTORY CHANGELOG; do 533 for docfile in README* HISTORY CHANGELOG; do
330 [[ -f ${docfile} ]] && dodoc ${docfile} 534 [[ -f ${docfile} ]] && dodoc ${docfile}
331 done 535 done
332 536
333 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 537 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
334 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 538 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
335 539
336 if [[ -n ${VDR_CONFD_FILE} ]]; then 540 if [[ -n ${VDR_CONFD_FILE} ]]; then
337 insinto /etc/conf.d
338 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN} 541 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
339 fi 542 fi
340 543
341 544
342 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 545 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
343 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 546 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
344 547
345 if [[ -n ${VDR_RCADDON_FILE} ]]; then 548 if [[ -n ${VDR_RCADDON_FILE} ]]; then
346 insinto "${VDR_RC_DIR}" 549 insinto "${VDR_RC_DIR}"
347 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 550 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
348 fi 551 fi
349
350
351
352 # Danger: Not using $ROOT here, as compile will also not use it !!!
353 # If vdr in $ROOT and / differ, plugins will not run anyway
354
355 insinto ${VDR_CHECKSUM_DIR}
356 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
357 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
358 else
359 if type -p md5sum >/dev/null 2>&1; then
360 cd ${S}
361 (
362 cd ${VDR_INCLUDE_DIR}
363 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
364 ) > header-md5-${PN}
365 doins header-md5-${PN}
366 fi
367 fi
368
369 create_plugindb_file
370} 552}
371 553
372vdr-plugin_pkg_postinst() { 554vdr-plugin_pkg_postinst() {
373 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then 555 vdr-plugin_print_enable_command
374 update_vdrplugindb 556
375 fi
376 elog
377 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
378 elog "To activate execute the following command:"
379 elog
380 elog " emerge --config ${PN}"
381 elog
382 if [[ -n "${VDR_CONFD_FILE}" ]]; then 557 if [[ -n "${VDR_CONFD_FILE}" ]]; then
383 elog "And have a look at the config-file" 558 elog "Please have a look at the config-file"
384 elog "/etc/conf.d/vdr.${VDRPLUGIN}" 559 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
385 elog 560 elog
386 fi 561 fi
387} 562}
388 563
389vdr-plugin_pkg_postrm() { 564vdr-plugin_pkg_postrm() {
390 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
391 remove_vdrplugindb
392 fi
393 delete_orphan_plugindb_file 565 delete_orphan_plugindb_file
394} 566}
395 567
396vdr-plugin_pkg_config_final() {
397 diff ${conf_orig} ${conf}
398 rm ${conf_orig}
399}
400
401vdr-plugin_pkg_config_old() {
402 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
403 if [[ -z "${INSTALLPLUGIN}" ]]; then
404 INSTALLPLUGIN="${VDRPLUGIN}"
405 fi
406 # First test if plugin is already inside PLUGINS
407 local conf=/etc/conf.d/vdr
408 conf_orig=${conf}.before_emerge_config
409 cp ${conf} ${conf_orig}
410
411 elog "Reading ${conf}"
412 if ! grep -q "^PLUGINS=" ${conf}; then
413 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
414 if [[ -n "${LINE}" ]]; then
415 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
416 else
417 echo 'PLUGINS=""' >> ${conf}
418 fi
419 unset LINE
420 fi
421
422 unset PLUGINS
423 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
424
425 active=0
426 for p in ${PLUGINS}; do
427 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
428 active=1
429 break;
430 fi
431 done
432
433 if [[ "${active}" == "1" ]]; then
434 elog "${INSTALLPLUGIN} already activated"
435 echo
436 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
437 if [[ "${answer}" != "yes" ]]; then
438 elog "aborted"
439 return
440 fi
441 elog "Removing ${INSTALLPLUGIN} from active plugins."
442 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
443 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
444 -e ${LINE}'s/ \( \)*/ /g' \
445 -e ${LINE}'s/ "/"/g' \
446 -e ${LINE}'s/" /"/g'
447
448 vdr-plugin_pkg_config_final
449 return
450 fi
451
452
453 elog "Adding ${INSTALLPLUGIN} to active plugins."
454 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
455 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
456 -e ${LINE}'s/ \( \)*/ /g' \
457 -e ${LINE}'s/ "/"/g' \
458 -e ${LINE}'s/" /"/g'
459
460 vdr-plugin_pkg_config_final
461}
462
463vdr-plugin_pkg_config_new() {
464 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
465 if [[ -z "${INSTALLPLUGIN}" ]]; then
466 INSTALLPLUGIN="${VDRPLUGIN}"
467 fi
468
469 active=0
470 # First test if plugin is already inside PLUGINS
471 local conf=/etc/conf.d/vdr.plugins
472 exec 3<${conf}
473 while read -u 3 line; do
474 [[ ${line} == "" ]] && continue
475 [[ ${line:0:1} == "#" ]] && continue
476 set -- ${line}
477 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
478 done
479 exec 3<&-
480
481 if [[ $active == 0 ]]; then
482 elog "Adding ${INSTALLPLUGIN} to active plugins."
483
484 # The pure edit process.
485 echo "${INSTALLPLUGIN}" >> "${conf}"
486 else
487 elog "${INSTALLPLUGIN} already activated"
488 echo
489 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
490 if [[ "${answer}" != "yes" ]]; then
491 elog "aborted"
492 return
493 fi
494 elog "Removing ${INSTALLPLUGIN} from active plugins."
495
496 # The pure edit process
497 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
498 fi
499}
500
501vdr-plugin_pkg_config() { 568vdr-plugin_pkg_config() {
502 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then 569 ewarn "emerge --config ${PN} is no longer supported"
503 vdr-plugin_pkg_config_new 570 vdr-plugin_print_enable_command
504 else
505 vdr-plugin_pkg_config_old
506 fi
507} 571}
508 572
509fix_vdr_libsi_include() 573case "${EAPI:-0}" in
510{ 574 2)
511 einfo "Fixing include of libsi-headers" 575 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
512 local f 576 ;;
513 for f; do 577 *)
514 sed -i "${f}" \
515 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
516 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
517 done
518}
519
520EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 578 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
579 ;;
580esac

Legend:
Removed from v.1.43  
changed lines
  Added in v.1.66

  ViewVC Help
Powered by ViewVC 1.1.20